//
//  shuntsynapse.m
//  Neuron1
//
//  Created by Leslie Smith on 05/10/2004.
//  Copyright 2004 __MyCompanyName__. All rights reserved.
//

#import "shuntsynapse.h"


@implementation shuntsynapse
- computeSynapseEffects: (double) timestep
{
	int i ;
	double logweight ;
	logweight = 0 ; // unnecessary
	if (weight != 0)
		logweight = log(weight) ;
	// set up the array alpharray (in synapse.h) with the fraction to use for each timestep.
	alphaarray[0] = 1 ; // 1st element always 1
	if (alpha == 0) // special: alpha == 0 for synapses where the whole fraction is decreased next timestep
	{
		lengthalphaeffect = 2 ;
		alphaarray[1] = weight ;
		return self ;
	}
	else
	{// normal situation
	 // calculate the fraction for 10 * 1/alpha microsteps
	 // and parcel them up for use by getSynapticContribution
		lengthalphaeffect = (int) ceil((3.0/alpha) * (1/timestep)) ;	
		if (lengthalphaeffect > MAXTIMESTEPEFFECT)
			NSLog(@"shuntsynapse:computeSynapseEffects. Overlong effect of alpha function. Increase MAXTIMESTEPEFFECT \n");
		// ensure it is > 1
		if (lengthalphaeffect == 1) lengthalphaeffect = 2 ;
		for (i=1;i<lengthalphaeffect;i++)
		{
			if (weight != 0)
			alphaarray[i] = exp(logweight/(lengthalphaeffect-1) );
			else alphaarray[i] = 0 ; // note that weight of 0 implies instant total shunt
		}
	}
	
	return self ;
}


- (float) getSynapticContribution: (double) current_time: (int) stepno 
{
	// returns fraction multiplied from activation
	float fraction;
	int timesincespike;
	
	int i ;
	if ((neverspiked) || (presynspikes == 0))
	{
		fraction = 1 ; // will be used multiplicatively
		return fraction ;
	}
	if (do_reset_alpha) 
	{
		// remove those presynaptic inputs which have arrived
		// but not those in the delay (i.e. in presynaptic axon)
		for (i=presynspikes-1;i>=0;i--)
			if ((stepno - lastspikesteps[i]) > 0)
				presynspikes-- ;
		fraction = 1 ; // will be used multiplicatively
		do_reset_alpha = NO ; // turn off alpha resetting here.
	}
	else
	{
		// multiply up contribution of all presynaptic spikes which have actually arrived
		fraction = 1 ; // will be used multiplicatively
		for (i=0; i< presynspikes; i++)
		{
			timesincespike = (stepno - lastspikesteps[i]) ;
			if ((timesincespike >= 0) && (timesincespike < lengthalphaeffect))
				fraction = fraction * alphaarray[stepno - lastspikesteps[i]] ;
		}
		// delete presyn spikes that have come to an end
		
		while ((presynspikes > 0) && ((stepno - lastspikesteps[presynspikes - 1]) >= lengthalphaeffect))
			presynspikes = presynspikes - 1 ;	
		
	}
	return fraction ;
}

- (syndatatype) getSynapseData 
{	syndatatype syn1 ;
	
	syn1 = [super getSynapseData] ;
	
	// fix those that need fixed in syn1 
	syn1.synapsetype[0] = 'm';	
	// add in those that are new
	// none
	return syn1 ;
}
@end
